<?php
namespace Itls\CryptoWp;

include_once plugin_dir_path(__FILE__) . '../lib/qrlib/autoload.php'; // !!!
include_once plugin_dir_path(__FILE__) . '../lib/btclib/autoload.php';

include_once plugin_dir_path(__FILE__) . 'itls-hd.php';
//$hd = new HD();

//include_once plugin_dir_path(__FILE__) . '../lib/hd.php'; // !!!
//$hd = new HD();

use chillerlan\QRCode\{QRCode, QROptions};



if (!class_exists('\Itls\CryptoWp\Btc')) {
    class Btc
    {
        public function __construct()
        {
            $this->id = 'ITLS_btc';
            $this->icon = plugin_dir_url(__FILE__) . '../assets/images/btc-logo.png';
        }

        public function get_btc_addr()
        {
            //global $hd;
            global $itls_wc_pay_gw_x1x_data, $itls_wp_helper;
            $ret = false;
            $oName = $itls_wc_pay_gw_x1x_data['options_name'];
            $options = get_option($oName);
            //$btcArray = $options['itls_crypto_btc'];

            if ($itls_wp_helper->checkUserData()) {
                //$itls_wp_helper->delUserData();
                $ret = $itls_wp_helper->getUserData();
            } else {

              $zpub = $options['itls_crypto_btc_zpub'];
              //$index = $this->get_btc_zpub_index();
              $index = self::get_btc_zpub_index();
              $path = '0/'.$index;

              $hd = new \Itls\CryptoWp\Hd();
              $hd->set_zpub($zpub);
              $ret = $hd->address_from_master_pub($path);


//              $hd = new HD();

//                $zpub = $options['itls_crypto_btc_zpub'];
//                $index = 0;
//                $path = '0/'.$index;

//HD::set_zpub($zpub);

                //$hd = new HD();
//                $hd->set_zpub($zpub);
//                $ret = $hd->address_from_master_pub($path);

// get Options ZpubIndex
// if there's no ZI = 0; write it to db;
// else ZI=ZI++;
// Calc new address

                //$tRet = $this->get_least_used_btc($btcArray);
                /*
                $tRet = $sochain->getFresh($btcArray); // !!!!
                if (strlen($tRet) > 15) {
                    $ret = $tRet;
                    $itls_wp_helper->putUserData($ret);
                }
                */
                //$ret = $zpub; //!!!! it works !!!!

            }
            //$ret = $sochain->getFresh($btcArray); // !!! test
            return $ret;
        }
/*
        public function get_least_used_btc($btcArray)
        {
            foreach ($btcArray as $k => $v) {
                // find the least used address
                $ret = $v;
            }
            return $ret;
        }
*/

/*
        public function get_btc_zpub_index()
        {
          global $itls_wc_pay_gw_x1x_data;
          //TODO:: maybe no need to update all options here?!!!

          $oName = $itls_wc_pay_gw_x1x_data['options_name'];
          $options = get_option($oName);

            $myOption = 'itls_crypto_btc_zpubindex';
            $res = 0;
            if (isset($options[$myOption])) {
                $res = $options[$myOption];
            }
            $options[$myOption] = $res + 1;
            update_option( $oName , $options );

            return $res;
        }
*/
        public function get_qr_code($walletAddress, $cryptoTotal)
        {
            //$writeDir = plugin_dir_path(__FILE__) . '../tmp/';
            //$readDir = plugin_dir_url(__FILE__) . '../tmp/';

            $qrData = $walletAddress;

            //$res = 'https://api.qrserver.com/v1/create-qr-code/?data=' . $qrData;

            $res = (new QRCode)->render($qrData);
            return $res;
        }
    }
}
