<?php

       function ITLS_add2array($arr, $k, $v)
        {
            $res = $arr[$k].=$v;
            return $res;
        }

        function ITLS_fl2name($tmp, $id)
        {
            $tmp = str_replace(" ", "", $tmp);
            $tmp = $tmp . '' . substr($id, -5);
            $tmp = strtolower($tmp);
            return $tmp;
        }

        function ITLS_text2slug($tmp, $rep='_')
        {
            $tmp = str_replace(" ", $rep, $tmp);
            $tmp = strtolower($tmp);
            return $tmp;
        }

        function ITLS_slug2text($tmp)
        {
            $tmp = str_replace("_", " ", $tmp);
            $tmp = ucwords($tmp);
            return $tmp;
        }

        function ITLS_font2id($tmp)
        {
            $tmp = str_replace(" ", "+", $tmp);
            return $tmp;
        }

        /**
         * Pull the feed
         */
        function ITLS_getRemote($url)
        {
            // remote data
            $response = wp_remote_get($url);

            if (is_wp_error($response) || !isset($response['body'])) {
                return;
            } // bad response

            // the good stuff
            $body = wp_remote_retrieve_body($response);

            if (is_wp_error($body)) {
                return;
            } // bad body

            // decode the data
            $data = json_decode($body, true);

            if (!$data || empty($data)) {
                return;
            } // bad data

            // final remote data
            return $data;
        }

