<?php
function ITLS_cd_drop_payment_table()
{
    global $wpdb;
    $tableName = $wpdb->prefix . 'cryptodec_payments';
    $query = "DROP TABLE IF EXISTS `$tableName`";
    $wpdb->query($query);
}

function ITLS_cd_create_payment_table()
{
    global $wpdb;
    $tableName = $wpdb->prefix . 'cryptodec_payments';
    $query = "CREATE TABLE IF NOT EXISTS `$tableName`
        (
            `id` bigint(12) unsigned NOT NULL AUTO_INCREMENT,
            `address` varchar(199) NOT NULL,
            `coin` varchar(7) NOT NULL,
            `hash` varchar(255) NULL,
            `hash_by` varchar(6) NULL,
            `order_id` bigint(10) NOT NULL DEFAULT '0',
            `order_total` decimal(32, 18) NOT NULL DEFAULT '0.000000000000000000',
            `order_status` varchar(24)  NOT NULL DEFAULT 'error',
            `order_ts` bigint(20) NOT NULL DEFAULT '0',
            PRIMARY KEY (`id`),
            UNIQUE KEY `unique_payment` (`order_id`, `order_total`),
            KEY `order_status` (`order_status`)
        );";
    $wpdb->query($query);
}
